﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WinCalc_winGrid_bool_columns
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraGrid.SetDataBinding(TestData(),null,false);
        }

        private DataTable TestData()
        {
            DataTable dtData = new DataTable();
            dtData.TableName = "Band 0";
            dtData.Columns.Add("BOOL_COLUMN", typeof(bool));
            dtData.Columns.Add("DOUBLE_COLUMN", typeof(double));

            DataRow dr = dtData.NewRow();
            dr[0] = true;
            dr[1] = 3.5;
            dtData.Rows.Add(dr);

            DataRow dr1 = dtData.NewRow();
            dr1[0] = true;
            dr1[1] = 2.5;
            dtData.Rows.Add(dr1);

            DataRow dr2 = dtData.NewRow();
            dr2[0] = false;
            dr2[1] = 5.6;
            dtData.Rows.Add(dr2);

            DataRow dr3 = dtData.NewRow();
            dr3[0] = false;
            dr3[1] = 4.5;
            dtData.Rows.Add(dr3);

            return dtData;

        }

        private void ultraGrid_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridColumn column = e.Layout.Bands[0].Columns.Add("TRUE_COLUMN");
            column.DataType = e.Layout.Bands[0].Columns["DOUBLE_COLUMN"].DataType;
            column.Formula = "if ([BOOL_COLUMN], [DOUBLE_COLUMN], 0)";

            column = e.Layout.Bands[0].Columns.Add("False_COLUMN");
            column.DataType = e.Layout.Bands[0].Columns["DOUBLE_COLUMN"].DataType;
            column.Formula = "if ([BOOL_COLUMN], 0, [DOUBLE_COLUMN])";
        }
    }
}
